//' DKFS-51 (C) Dmitriy Korabelnikov 2005-2008.
//' This software DKFS-51 is a disk operating system
//' for 8-bit and 16-bit microcontrollers based on I2C/SPI/SD-Card FLASH memory.
//' DKFS-51 is intended promarily for MCS-51 family of microcontrollers
//' and Keil C51 compiler but can be also used for other 8 and 16-bit
//' microcontrollers (like AVR, ATMEGA) assuming rewritten asm, interrupt
//' and hardware code (like timers and serial port inicialization).
//' In the current state this is a COMMERCIAL software.
//' Please contact with author by e-mail d_korabelnikov@mail.ru
//' if you want to use this code in your devices or applications.
//' Next text is Russian Win-1251
//' DKFS-51 (C)   2005-2008.
//' DKFS-51      8  16-
//'    I2C/SPI/SD-Card FLASH .
//' DKFS-51     MCS-51  
//'  Keil C51    
//'   8  16-  (AVR,ATMEGA)  
//'   ,     
//' (      ).
//'      .    
//'  e-mail d_korabelnikov@mail.ru
//'           .
code unsigned char maxdays[]={0,31,28,31,30,31,30,31,31,30,31,30,31};

//   UNIX 
//  -  2000 (0)  2037 (37) (  31 )
long usec(char year,char month, char date,char hr, char min, char sec)
{long secv;data unsigned char q;bit leapyear;
leapyear=((year % 4)==0);
secv=0L;
for (q=70;q<100+year;q++)
                {secv+=(365L*86400L);if ((q % 4)==0) secv+=86400L;}
for (q=1;q<month;q++)
                {secv+=(long)maxdays[q]*86400L;if (leapyear &&(q==2)) secv+=86400L;}
secv=secv+(long)(date-1)*86400L+(long)hr*3600L+(long)min*60L+(long)sec;
return secv;}

//UNIX   
//   - long ( 0  0x7FFFFFFF)
void btime(char *buf,long sectime0)
{unsigned char sec,min,hr,date,month,year,q;long delta;bit leapyear;long sectime;
sec=0;min=0;hr=0;date=1;month=1;year=70;
sectime=sectime0;
if (sectime==0) goto quit;
while (sectime>0)
        {delta=(365L*86400L);if ((year % 4)==0) delta+=86400L;sectime-=delta;year++;}
if (sectime==0) goto quit;
sectime+=delta;year--;
leapyear=((year % 4)==0);
while (sectime>0)
	{delta=(long)maxdays[month]*86400L;
         if (leapyear && (month==2)) delta+=86400L;sectime-=delta;month++;}
if (sectime==0) goto quit;
sectime+=delta;month--;
q=(unsigned char)(sectime/86400L);sectime=sectime % 86400L;
date=q+1;
hr=(char)(sectime/3600L);sectime=sectime % 3600L;
min=(char)(sectime/60L);sec=(char)(sectime % 60L);
quit:
year=year % 100;
*buf++=sec;*buf++=min;*buf++=hr;*buf++=date;*buf++=month;*buf++=year;}
