//' DKFS-51 (C) Dmitriy Korabelnikov 2005-2008.
//' This software DKFS-51 is a disk operating system
//' for 8-bit and 16-bit microcontrollers based on I2C/SPI/SD-Card FLASH memory.
//' DKFS-51 is intended promarily for MCS-51 family of microcontrollers
//' and Keil C51 compiler but can be also used for other 8 and 16-bit
//' microcontrollers (like AVR, ATMEGA) assuming rewritten asm, interrupt
//' and hardware code (like timers and serial port inicialization).
//' In the current state this is a COMMERCIAL software.
//' Please contact with author by e-mail d_korabelnikov@mail.ru
//' if you want to use this code in your devices or applications.
//' Next text is Russian Win-1251
//' DKFS-51 (C)   2005-2008.
//' DKFS-51      8  16-
//'    I2C/SPI/SD-Card FLASH .
//' DKFS-51     MCS-51  
//'  Keil C51    
//'   8  16-  (AVR,ATMEGA)  
//'   ,     
//' (      ).
//'      .    
//'  e-mail d_korabelnikov@mail.ru
//'           .
#define maxdrive       2
xdata char diskdrive;
#define demomaxsector  120
#define demosectorsize 128
//  2   ,   LOG2(128)=7
#define demosectorshift  7
#define demodisksize  (demomaxsector*(demosectorsize+2))

xdata unsigned char demodisk0[demodisksize];
xdata unsigned char demodisk1[demodisksize];

void iwrite(unsigned char *memory,unsigned int addr,unsigned int nbytes)
{if (diskdrive==0) memcpy(&demodisk0[addr],memory,nbytes);
 else if (diskdrive==1) memcpy(&demodisk1[addr],memory,nbytes);}


void iread(unsigned char *memory,unsigned int addr,unsigned int nbytes)
{if (diskdrive==0) memcpy(memory,&demodisk0[addr],nbytes);
 else if (diskdrive==1) memcpy(memory,&demodisk1[addr],nbytes);
}
