'' DKFS-51 (C) Dmitriy Korabelnikov 2005-2008.
'' This software DKFS-51 is a disk operating system
'' for 8-bit and 16-bit microcontrollers based on I2C/SPI/SD-Card FLASH memory.
'' DKFS-51 is intended promarily for MCS-51 family of microcontrollers
'' and Keil C51 compiler but can be also used for other 8 and 16-bit
'' microcontrollers (like AVR, ATMEGA) assuming rewritten asm, interrupt
'' and hardware code (like timers and serial port inicialization).
'' In the current state this is a COMMERCIAL software.
'' Please contact with author by e-mail d_korabelnikov@mail.ru
'' if you want to use this code in your devices or applications.
'' Next text is Russian Win-1251
'' DKFS-51 (C)   2005-2008.
'' DKFS-51      8  16-
''    I2C/SPI/SD-Card FLASH .
'' DKFS-51     MCS-51  
''  Keil C51    
''   8  16-  (AVR,ATMEGA)  
''   ,     
'' (      ).
''      .    
''  e-mail d_korabelnikov@mail.ru
''           .
DECLARE FUNCTION crc& (v&)
DEFLNG A-Z
DIM t(256)
FOR i = 0 TO 255
t(i) = crc(i)
NEXT i

OPEN "o", 1, "crc16tab.a51"
print #1,"getcrc16hi:"
restore cod:for i=1 to 3:read a$:? #1,space$(4);a$:next
mode=1:gosub writetable ' write MSB CRC16 table
print #1,"getcrc16lo:"
restore cod:for i=1 to 3:read a$:? #1,space$(4);a$:next
mode=0:gosub writetable ' write LSB CRC16 table
close
end

writetable:
n = -1
FOR j = 0 TO 31
PRINT #1, " db ";
FOR i = 0 TO 7
n = n + 1
if mode=0 then d=t(n) and 255 else d=(t(n) and &h0000ff00&)/256
a$ = HEX$(d)
a$ = STRING$(3 - LEN(a$), "0") + a$ + "h"
if n=0 then
PRINT #1,space$(5); '   t(0)
else
PRINT #1, a$; : IF i < 7 THEN PRINT #1, ",";  ELSE PRINT #1, ""
endif
NEXT
NEXT
PRINT #1,""
return

cod:
data	"jz $+3; if a=0 then return 0 (jump to RET)"
data	"movc a,@a+PC; else return a value from table"
data	"ret"

FUNCTION crc (v)
q = 256 * v

FOR i = 1 TO 8
q = 2 * q
IF (q AND 65536) THEN q = (q XOR &H1021)
NEXT i
crc = (q AND 65535)
END FUNCTION

