//' DKFS-51 (C) Dmitriy Korabelnikov 2005-2008.
//' This software DKFS-51 is a disk operating system
//' for 8-bit and 16-bit microcontrollers based on I2C/SPI/SD-Card FLASH memory.
//' DKFS-51 is intended promarily for MCS-51 family of microcontrollers
//' and Keil C51 compiler but can be also used for other 8 and 16-bit
//' microcontrollers (like AVR, ATMEGA) assuming rewritten asm, interrupt
//' and hardware code (like timers and serial port inicialization).
//' In the current state this is a COMMERCIAL software.
//' Please contact with author by e-mail d_korabelnikov@mail.ru
//' if you want to use this code in your devices or applications.
//' Next text is Russian Win-1251
//' DKFS-51 (C)   2005-2008.
//' DKFS-51      8  16-
//'    I2C/SPI/SD-Card FLASH .
//' DKFS-51     MCS-51  
//'  Keil C51    
//'   8  16-  (AVR,ATMEGA)  
//'   ,     
//' (      ).
//'      .    
//'  e-mail d_korabelnikov@mail.ru
//'           .
uns char token[32];

uns char tokin;
tokbegin()
{tokin=0;token[0]=0;}

bit toknext()
{uns char i;
token[0]=0;
while (rxbuf[tokin]<=32) {if ((tokin>120) || (rxbuf[tokin]==0)) return 0;tokin++;}
i=0;
while ((rxbuf[tokin]>32) && (i<31)) {token[i]=rxbuf[tokin];i++;tokin++;}
token[i]=0;
return 1;
}




void cmd()
{
while (1)
{printf("\n%c>",diskdrive+'A');inputrs();
tokbegin();toknext();
if (strcmp(token,"dir")==0) dircmd();
else if (strcmp(token,"fmt")==0) diskformat('A');
else if (strcmp(token,"test0")==0) test0_crcplay();
else if (strcmp(token,"test1")==0) test1_sector_ops();
else if (strcmp(token,"test2")==0) test2_format_test();
else if (strcmp(token,"test3")==0) test3_hello_dkdos();
else if (strcmp(token,"test4")==0) test4_look_inside();
else if (strcmp(token,"test5")==0) test5_append_file();
else printf("%s -  \n",token);
}
}

